/* autogenerated by embedmodel.py.  DO NOT EDIT */

#include <zebra.h>
#include "yang.h"

static const char model[] =
	"// SPDX-License-Identifier: BSD-2-Clause\n"
	"submodule frr-bgp-neighbor {\n"
	"  yang-version 1.1;\n"
	"\n"
	"  belongs-to frr-bgp {\n"
	"    prefix \"bgp\";\n"
	"  }\n"
	"\n"
	"  include \"frr-bgp-common-multiprotocol\";\n"
	"\n"
	"  include \"frr-bgp-common-structure\";\n"
	"\n"
	"  organization\n"
	"    \"FRRouting\";\n"
	"  contact\n"
	"    \"FRR Users List: <mailto:frog@lists.frrouting.org> FRR Development\n"
	"     List: <mailto:dev@lists.frrouting.org>\";\n"
	"  description\n"
	"    \"This submodule contains general data definitions for use in BGP neighbor.\n"
	"\n"
	"     Copyright 2020 FRRouting\n"
	"\n"
	"     Redistribution and use in source and binary forms, with or without\n"
	"     modification, are permitted provided that the following conditions\n"
	"     are met:\n"
	"\n"
	"     1. Redistributions of source code must retain the above copyright notice,\n"
	"     this list of conditions and the following disclaimer.\n"
	"\n"
	"     2. Redistributions in binary form must reproduce the above copyright\n"
	"     notice, this list of conditions and the following disclaimer in the\n"
	"     documentation and/or other materials provided with the distribution.\n"
	"\n"
	"     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n"
	"     \\\"AS IS\\\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n"
	"     LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n"
	"     A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n"
	"     HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n"
	"     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n"
	"     LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\n"
	"     DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\n"
	"     THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n"
	"     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE\n"
	"     OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\";\n"
	"\n"
	"  revision 2019-12-03 {\n"
	"    description\n"
	"      \"Initial revision.\";\n"
	"  }\n"
	"\n"
	"  grouping neighbor-parameters {\n"
	"    leaf password {\n"
	"      type string {\n"
	"        length \"1..254\";\n"
	"      }\n"
	"      description\n"
	"        \"Actual password.\";\n"
	"    }\n"
	"\n"
	"    leaf ttl-security {\n"
	"      type uint8;\n"
	"      description\n"
	"        \"BGP Time To Live (TTL) security check.\";\n"
	"      reference\n"
	"        \"RFC 5082: The Generalized TTL Security Mechanism\n"
	"         (GTSM),\n"
	"         RFC 7454: BGP Operations and Security.\";\n"
	"    }\n"
	"\n"
	"    leaf solo {\n"
	"      type boolean;\n"
	"      default \"false\";\n"
	"      description\n"
	"        \"Solo peer - part of its own update group.\";\n"
	"    }\n"
	"\n"
	"    leaf enforce-first-as {\n"
	"      type boolean;\n"
	"      default \"true\";\n"
	"      description\n"
	"        \"When set to \'true\' it will enforce the first AS for EBGP routes.\";\n"
	"    }\n"
	"\n"
	"    leaf description {\n"
	"      type string;\n"
	"      description\n"
	"        \"An optional textual description (intended primarily for use\n"
	"         with a peer or group.\";\n"
	"    }\n"
	"\n"
	"    leaf passive-mode {\n"
	"      type boolean;\n"
	"      default \"false\";\n"
	"      description\n"
	"        \"Don\'t send open messages to this neighbor.\";\n"
	"    }\n"
	"\n"
	"    uses neighbor-update-source;\n"
	"\n"
	"    uses structure-neighbor-group-ebgp-multihop;\n"
	"\n"
	"    uses neighbor-local-as-options;\n"
	"\n"
	"    uses neighbor-bfd-options;\n"
	"\n"
	"    uses structure-neighbor-group-admin-shutdown;\n"
	"\n"
	"    uses structure-neighbor-group-graceful-restart;\n"
	"\n"
	"    uses structure-neighbor-config-timers;\n"
	"\n"
	"    container afi-safis {\n"
	"      description\n"
	"        \"List of address-families associated with the BGP\n"
	"         instance.\";\n"
	"      list afi-safi {\n"
	"        key \"afi-safi-name\";\n"
	"        description\n"
	"          \"AFI, SAFI configuration available for the\n"
	"           neighbour or group.\";\n"
	"        uses mp-afi-safi-config;\n"
	"\n"
	"        leaf enabled {\n"
	"          type boolean;\n"
	"          description\n"
	"            \"This leaf indicates whether the IPv4 Unicast AFI, SAFI is\n"
	"             enabled for the neighbour or group.\";\n"
	"        }\n"
	"\n"
	"        uses mp-all-afi-safi-list-contents;\n"
	"      }\n"
	"    }\n"
	"  }\n"
	"}\n"
	"";

static struct yang_module_embed embed = {
	.mod_name = "frr-bgp",
	.mod_rev = "",
	.sub_mod_name = "frr-bgp-neighbor",
	.sub_mod_rev = "2019-12-03",
	.data = model,
	.format = LYS_IN_YANG,
};

static void embed_register(void) __attribute__((_CONSTRUCTOR(2000)));
static void embed_register(void)
{
	yang_module_embed(&embed);
}
