/* autogenerated by embedmodel.py.  DO NOT EDIT */

#include <zebra.h>
#include "yang.h"

static const char model[] =
	"// SPDX-License-Identifier: BSD-2-Clause\n"
	"module frr-bgp-types {\n"
	"  yang-version 1.1;\n"
	"  namespace \"http://frrouting.org/yang/bgp-types\";\n"
	"  prefix frr-bt;\n"
	"\n"
	"  organization\n"
	"    \"FRRouting\";\n"
	"  contact\n"
	"    \"FRR Users List: <mailto:frog@lists.frrouting.org> FRR Development\n"
	"     List: <mailto:dev@lists.frrouting.org>\";\n"
	"  description\n"
	"    \"This module contains general data definitions for use in BGP.\n"
	"\n"
	"     Copyright 2020 FRRouting\n"
	"\n"
	"     Redistribution and use in source and binary forms, with or without\n"
	"     modification, are permitted provided that the following conditions\n"
	"     are met:\n"
	"\n"
	"     1. Redistributions of source code must retain the above copyright notice,\n"
	"     this list of conditions and the following disclaimer.\n"
	"\n"
	"     2. Redistributions in binary form must reproduce the above copyright\n"
	"     notice, this list of conditions and the following disclaimer in the\n"
	"     documentation and/or other materials provided with the distribution.\n"
	"\n"
	"     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n"
	"     \\\"AS IS\\\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n"
	"     LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n"
	"     A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n"
	"     HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n"
	"     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n"
	"     LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\n"
	"     DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\n"
	"     THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n"
	"     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE\n"
	"     OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\";\n"
	"\n"
	"  revision 2019-12-03 {\n"
	"    description\n"
	"      \"Initial revision.\";\n"
	"  }\n"
	"\n"
	"  typedef plist-ref {\n"
	"    type string;\n"
	"  }\n"
	"\n"
	"  typedef access-list-ref {\n"
	"    type string;\n"
	"  }\n"
	"\n"
	"  typedef as-path-filter-ref {\n"
	"    type string;\n"
	"  }\n"
	"\n"
	"  typedef bgp-instance-type {\n"
	"    type enumeration {\n"
	"      enum \"default\" {\n"
	"        value 1;\n"
	"        description\n"
	"          \"BGP instance default.\";\n"
	"      }\n"
	"      enum \"vrf\" {\n"
	"        value 2;\n"
	"        description\n"
	"          \"BGP instance vrf.\";\n"
	"      }\n"
	"      enum \"view\" {\n"
	"        value 3;\n"
	"        description\n"
	"          \"BGP instance view.\";\n"
	"      }\n"
	"    }\n"
	"  }\n"
	"\n"
	"  typedef as-type {\n"
	"    type enumeration {\n"
	"      enum \"as-specified\" {\n"
	"        value 1;\n"
	"        description\n"
	"          \"AS has explicitly specified value.\";\n"
	"      }\n"
	"      enum \"internal\" {\n"
	"        value 2;\n"
	"        description\n"
	"          \"Internal BGP peer.\";\n"
	"      }\n"
	"      enum \"external\" {\n"
	"        value 3;\n"
	"        description\n"
	"          \"External BGP peer.\";\n"
	"      }\n"
	"    }\n"
	"  }\n"
	"\n"
	"  typedef add-path-type {\n"
	"    type enumeration {\n"
	"      enum \"all\" {\n"
	"        value 1;\n"
	"        description\n"
	"          \"To advertise all paths to a neighbor.\";\n"
	"      }\n"
	"      enum \"per-as\" {\n"
	"        value 2;\n"
	"        description\n"
	"          \"To advertise the best path per each neighboring AS.\";\n"
	"      }\n"
	"      enum \"none\" {\n"
	"        value 3;\n"
	"        description\n"
	"          \"Add path feature is disabled.\";\n"
	"      }\n"
	"    }\n"
	"  }\n"
	"\n"
	"  typedef bfd-session-type {\n"
	"    type enumeration {\n"
	"      enum \"single-hop\" {\n"
	"        value 1;\n"
	"        description\n"
	"          \"Single hop session.\";\n"
	"      }\n"
	"      enum \"multi-hop\" {\n"
	"        value 2;\n"
	"        description\n"
	"          \"Multiple hop session.\";\n"
	"      }\n"
	"      enum \"not-configured\" {\n"
	"        value 3;\n"
	"        description\n"
	"          \"Not Configured.\";\n"
	"      }\n"
	"    }\n"
	"  }\n"
	"\n"
	"  typedef direction {\n"
	"    type enumeration {\n"
	"      enum \"in\" {\n"
	"        value 1;\n"
	"        description\n"
	"          \"IN, ingress, Rx.\";\n"
	"      }\n"
	"      enum \"out\" {\n"
	"        value 2;\n"
	"        description\n"
	"          \"OUT, egress, Tx.\";\n"
	"      }\n"
	"    }\n"
	"  }\n"
	"}\n"
	"";

static struct yang_module_embed embed = {
	.mod_name = "frr-bgp-types",
	.mod_rev = "2019-12-03",
	.sub_mod_name = "",
	.sub_mod_rev = "",
	.data = model,
	.format = LYS_IN_YANG,
};

static void embed_register(void) __attribute__((_CONSTRUCTOR(2000)));
static void embed_register(void)
{
	yang_module_embed(&embed);
}
