/* autogenerated by embedmodel.py.  DO NOT EDIT */

#include <zebra.h>
#include "yang.h"

static const char model[] =
	"module ietf-netconf-with-defaults {\n"
	"\n"
	"   namespace \"urn:ietf:params:xml:ns:yang:ietf-netconf-with-defaults\";\n"
	"\n"
	"   prefix ncwd;\n"
	"\n"
	"   import ietf-netconf { prefix nc; }\n"
	"\n"
	"   organization\n"
	"    \"IETF NETCONF (Network Configuration Protocol) Working Group\";\n"
	"\n"
	"   contact\n"
	"    \"WG Web:   <http://tools.ietf.org/wg/netconf/>\n"
	"\n"
	"     WG List:  <netconf@ietf.org>\n"
	"\n"
	"     WG Chair: Bert Wijnen\n"
	"               <bertietf@bwijnen.net>\n"
	"\n"
	"     WG Chair: Mehmet Ersue\n"
	"               <mehmet.ersue@nsn.com>\n"
	"\n"
	"     Editor: Andy Bierman\n"
	"             <andy.bierman@brocade.com>\n"
	"\n"
	"     Editor: Balazs Lengyel\n"
	"             <balazs.lengyel@ericsson.com>\";\n"
	"\n"
	"   description\n"
	"    \"This module defines an extension to the NETCONF protocol\n"
	"     that allows the NETCONF client to control how default\n"
	"     values are handled by the server in particular NETCONF\n"
	"     operations.\n"
	"\n"
	"     Copyright (c) 2011 IETF Trust and the persons identified as\n"
	"     the document authors.  All rights reserved.\n"
	"\n"
	"     Redistribution and use in source and binary forms, with or\n"
	"     without modification, is permitted pursuant to, and subject\n"
	"     to the license terms contained in, the Simplified BSD License\n"
	"     set forth in Section 4.c of the IETF Trust\'s Legal Provisions\n"
	"     Relating to IETF Documents\n"
	"     (http://trustee.ietf.org/license-info).\n"
	"\n"
	"     This version of this YANG module is part of RFC 6243; see\n"
	"     the RFC itself for full legal notices.\";\n"
	"\n"
	"   revision 2011-06-01 {\n"
	"     description\n"
	"       \"Initial version.\";\n"
	"     reference\n"
	"      \"RFC 6243: With-defaults Capability for NETCONF\";\n"
	"   }\n"
	"\n"
	"   typedef with-defaults-mode {\n"
	"      description\n"
	"        \"Possible modes to report default data.\";\n"
	"      reference\n"
	"         \"RFC 6243; Section 3.\";\n"
	"      type enumeration {\n"
	"         enum report-all {\n"
	"             description\n"
	"               \"All default data is reported.\";\n"
	"             reference\n"
	"               \"RFC 6243; Section 3.1\";\n"
	"         }\n"
	"         enum report-all-tagged {\n"
	"             description\n"
	"               \"All default data is reported.\n"
	"                Any nodes considered to be default data\n"
	"                will contain a \'default\' XML attribute,\n"
	"                set to \'true\' or \'1\'.\";\n"
	"             reference\n"
	"               \"RFC 6243; Section 3.4\";\n"
	"         }\n"
	"         enum trim {\n"
	"             description\n"
	"               \"Values are not reported if they contain the default.\";\n"
	"             reference\n"
	"               \"RFC 6243; Section 3.2\";\n"
	"         }\n"
	"         enum explicit {\n"
	"             description\n"
	"               \"Report values that contain the definition of\n"
	"                explicitly set data.\";\n"
	"             reference\n"
	"               \"RFC 6243; Section 3.3\";\n"
	"         }\n"
	"     }\n"
	"   }\n"
	"\n"
	"   grouping with-defaults-parameters {\n"
	"     description\n"
	"       \"Contains the <with-defaults> parameter for control\n"
	"        of defaults in NETCONF retrieval operations.\";\n"
	"\n"
	"     leaf with-defaults {\n"
	"       description\n"
	"         \"The explicit defaults processing mode requested.\";\n"
	"       reference\n"
	"         \"RFC 6243; Section 4.5.1\";\n"
	"\n"
	"       type with-defaults-mode;\n"
	"     }\n"
	"   }\n"
	"\n"
	"   // extending the get-config operation\n"
	"   augment /nc:get-config/nc:input {\n"
	"       description\n"
	"         \"Adds the <with-defaults> parameter to the\n"
	"          input of the NETCONF <get-config> operation.\";\n"
	"       reference\n"
	"         \"RFC 6243; Section 4.5.1\";\n"
	"\n"
	"       uses with-defaults-parameters;\n"
	"   }\n"
	"\n"
	"   // extending the get operation\n"
	"   augment /nc:get/nc:input {\n"
	"       description\n"
	"         \"Adds the <with-defaults> parameter to\n"
	"          the input of the NETCONF <get> operation.\";\n"
	"       reference\n"
	"         \"RFC 6243; Section 4.5.1\";\n"
	"\n"
	"       uses with-defaults-parameters;\n"
	"   }\n"
	"\n"
	"   // extending the copy-config operation\n"
	"   augment /nc:copy-config/nc:input {\n"
	"       description\n"
	"         \"Adds the <with-defaults> parameter to\n"
	"          the input of the NETCONF <copy-config> operation.\";\n"
	"       reference\n"
	"         \"RFC 6243; Section 4.5.1\";\n"
	"\n"
	"       uses with-defaults-parameters;\n"
	"   }\n"
	"}\n"
	"";

static struct yang_module_embed embed = {
	.mod_name = "ietf-netconf-with-defaults",
	.mod_rev = "2011-06-01",
	.sub_mod_name = "",
	.sub_mod_rev = "",
	.data = model,
	.format = LYS_IN_YANG,
};

static void embed_register(void) __attribute__((_CONSTRUCTOR(2000)));
static void embed_register(void)
{
	yang_module_embed(&embed);
}
